#ifndef CAMERA_H_
#define CAMERA_H_

#include <gmath/gmath.h>

class Camera {
public:
	Camera();
	Camera(float phi, float theta, float distance, float fov);
	virtual ~Camera();

	virtual Mat4 get_view_matrix() const = 0;
	virtual void use() const;
};

class OrbitCamera : public Camera {
protected:
	float theta;
	float phi;
	float distance;

public:
	OrbitCamera();
	OrbitCamera(float theta, float phi, float distance);
	virtual ~OrbitCamera();

	virtual Mat4 get_view_matrix() const override;

	void set_orbit_params(float phi, float theta, float distance);
};

Mat4 calc_projection_matrix(float f, float n, float aspect, float fov);

#endif // CAMERA_H_