#include <GL/glew.h>
#include <stdio.h>

#include "opengl/opengl.h"

extern GLFWwindow *win;
extern int win_h;
extern int win_w;

bool init_opengl()
{
	if(!glfwInit()) {
		fprintf(stderr, "Failed to initialize GLFW.\n");
		return false;
	}

	glfwWindowHint(GLFW_CONTEXT_VERSION_MAJOR, 4);
	glfwWindowHint(GLFW_CONTEXT_VERSION_MINOR, 5);

	if(!(win = glfwCreateWindow(win_w, win_h, "glcow", 0, 0))) {
		fprintf(stderr, "Failed to create window.\n");
		return false;
	}
	glfwMakeContextCurrent(win);

	glewInit();
	return true;
}

void cleanup_opengl()
{
	if(win) {
		glfwDestroyWindow(win);
	}
	glfwTerminate();
}

void display_opengl()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glClearColor(0.5, 0.5, 0.5, 1.0);

}