#include <GL/glew.h>

#include "object.h"
#include "scene.h"

#include "opengl/mesh-gl.h"
#include "opengl/renderer-gl.h"
#include "opengl/shader-gl.h"
#include "opengl/texture-gl.h"

RendererGL::RendererGL()
{
	sprog = 0;
	scene = 0;
	camera = 0;
}

RendererGL::RendererGL(ShaderProgram *sprog, Scene *scene, Camera *camera)
{
	this->sprog = sprog;
	this->scene = scene;
	this->camera = camera;
}

RendererGL::~RendererGL()
{
}

bool RendererGL::create()
{
	return true;
}

void RendererGL::draw_object(Object *object) const
{
	object->mesh->draw();
}

void RendererGL::draw() const
{
	//TODO
	/* set state, uniforms */
	sprog->use();
	for(size_t i=0; i<scene->objects.size(); i++) {
		draw_object(scene->objects[i]);
	}
}