#ifndef RENDERER_GL_H_
#define RENDERER_GL_H_

#include "renderer.h"

class Scene;
class Object;
class Camera;

class RendererGL : public Renderer {
protected:
	virtual void draw_object(Object *object) const override;
public:
	RendererGL();
	RendererGL(ShaderProgram *sprog, Scene *scene, Camera *camera);

	virtual ~RendererGL();

	bool load_program(ShaderProgram *sprog);

	virtual bool create() override; // load shader prog, scene data etc
	virtual void draw() const override; // set state from camera, set uniforms
};

#endif // RENDERER_GL_H_